ZOJ 3203 Light Bulb【可求出极值的单峰函数】

来源:互联网 发布:淘宝客和返利网是什么 编辑:程序博客网 时间:2024/04/28 00:36

链接:

http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemCode=3203

http://acm.hust.edu.cn/vjudge/contest/view.action?cid=28708#problem/A


Light Bulb

Time Limit: 1 Second      Memory Limit: 32768 KB

Compared to wildleopard's wealthiness, his brother mildleopard is rather poor. His house is narrow and he has only one light bulb in his house. Every night, he is wandering in his incommodious house, thinking of how to earn more money. One day, he found that the length of his shadow was changing from time to time while walking between the light bulb and the wall of his house. A sudden thought ran through his mind and he wanted to know the maximum length of his shadow.

Input

The first line of the input contains an integer T (T <= 100), indicating the number of cases.

Each test case contains three real numbers Hh and D in one line. H is the height of the light bulb while h is the height of mildleopard. D is distance between the light bulb and the wall. All numbers are in range from 10-2 to 103, both inclusive, and H - h >= 10-2.

Output

For each test case, output the maximum length of mildleopard's shadow in one line, accurate up to three decimal places..

Sample Input

32 1 0.52 0.5 34 3 4

Sample Output

1.0000.7504.000


Author: GUAN, Yao
Source: The 6th Zhejiang Provincial Collegiate Programming Contest
Submit    Status


算法:利用函数的凸性



思路一:




 L = 0 时,倾斜角越小 shadow 越长
所以 L 正好为 0 时,  X 的长度为左极限 

(H-h)/ X = H / D 

所以 X =  (H-h)*D / H ,left = X = (H-h)*D / H

明显可以看到右边的极限就是 X = D , 从而 right = D

也就是如果用所谓的三分法 X 的取值区间是 【left, right】

下面再分析假设 X 已经知道了,如何求出 shadow = D-X+L


L / H = ? / (D + ?) ..........................................(1)

tan(a) = L / ? = (H-h) / X  可以得到 ? = L *X / (H-h) 带入 (1)

可以得到 L = H - D*(H-h)/ X

所以 shadow = D - X + L = D+H - 【X+ (H-h)*D / X】

要使得 shadow 最大 , 则 【】中的函数值最小

注意到 【】中的值由  X 确定 ,而 前面我们已经确定了 X 的区间,

容易看出 【】中的函数是个单峰函数:



根据 a^2 + b^2 >= 2ab 成立的条件是 a = b
所以我们可以确定如果 X = (H-h)*D / X 求出的值就是上图中的 X0

那么要使得【】中的值最小,结果是显然的了。既然能确定极值点,那么也没有必要用三分了

分下面三种情况即可求出满足条件的 X 使得shadow 最大 :

(1) X 的取值范围覆盖了 X0: X = X0
(2) X 的取值范围所在的区间单调递减【right <= X0】: X = right
(3) X 的取值范围所在的区间单调递增【left >= X0】: X = left

把所求的 X 带入上面的shadow 公式就是答案了。

想到根据函数的极值求主要是想的是三分图中的 X 本来就比较复杂了,虽然弄到这一步三分和求极值都一样。
但是如果真的用三分的思路的话, 还是觉得 荆红浅醉 童鞋的三分 L 比较好,
虽然无法轻易的求出极值点,但是至少可以一眼看出 L 的取值范围是【0, H】话说要是所有的三分都能求出极值点,那么也 就失去了三分的意义了。

学妹的思路:三分 L

http://www.cnblogs.com/riddle/p/3251109.html

令所求 shadow =  S + L
PS : S 就是上图的 D - X

由 L / H = ? / (D+?)      可以得到  ?= (L*D)  /  (H-L)

而 L / h = ? / (S+ ?)      可得 S = ?* (h-L) / L   =  D*(h-L) / (H-L)   前面又已经确定了 L 的范围【0, H】

shadow = S + L 随便乱搞都可以三分出来了。小朋友们的思路更好。大笑





code:

思路一的:
#include<stdio.h>#include<string.h>#include<math.h>int main(){    int T;    double H,h,D;    scanf("%d", &T);    while(T--)    {        scanf("%lf%lf%lf", &H,&h,&D);        double x1 = (H-h)*D/H;        double x2 = D;        double x0 = sqrt(D*(H-h));        double x;        if(x1 <= x0 && x0 <= x2) x = x0;        else if(x0 <= x1) x = x1;        else if(x0 >= x2) x = x2;        double ans = D+H- (x + (H-h)*D/x);        printf("%.3lf\n", ans);    }    return 0;}